Attribute VB_Name = "basHand"
Option Explicit
Public Type PALETTEENTRY
    peRed As Byte
    peGreen As Byte
    peBlue As Byte
    peFlags As Byte
End Type
Public Type LOGPALETTE
    palVersion As Integer
    palNumEntries As Integer
    palPalEntry(0 To 255) As PALETTEENTRY
End Type
Public Type PIXELFORMATDESCRIPTOR
    nSize As Integer
    nVersion As Integer
    dwFlags As Long
    iPixelType As Byte
    cColorBits As Byte
    cRedBits As Byte
    cRedShift As Byte
    cGreenBits As Byte
    cGreenShift As Byte
    cBlueBits As Byte
    cBlueShift As Byte
    cAlphaBits As Byte
    cAlphaShift As Byte
    cAccumBits As Byte
    cAccumRedBits As Byte
    cAccumGreenBits As Byte
    cAccumBlueBits As Byte
    cAccumAlpgaBits As Byte
    cDepthBits As Byte
    cStencilBits As Byte
    cAuxBuffers As Byte
    iLayerType As Byte
    bReserved As Byte
    dwLayerMask As Long
    dwVisibleMask As Long
    dwDamageMask As Long
End Type

Const PFD_TYPE_RGBA = 0
Const PFD_TYPE_COLORINDEX = 1
Const PFD_MAIN_PLANE = 0
Const PFD_DOUBLEBUFFER = 1
Const PFD_DRAW_TO_WINDOW = &H4
Const PFD_SUPPORT_OPENGL = &H20
Const PFD_NEED_PALETTE = &H80

Public Declare Function ChoosePixelFormat Lib "gdi32" (ByVal hDC As Long, pfd As PIXELFORMATDESCRIPTOR) As Long
Public Declare Function CreatePalette Lib "gdi32" (pPal As LOGPALETTE) As Long
Public Declare Sub DeleteObject Lib "gdi32" (hObject As Long)
Public Declare Sub DescribePixelFormat Lib "gdi32" (ByVal hDC As Long, ByVal PixelFormat As Long, ByVal nBytes As Long, pfd As PIXELFORMATDESCRIPTOR)
Public Declare Function GetDC Lib "gdi32" (ByVal hWnd As Long) As Long
Public Declare Function GetPixelFormat Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Sub GetSystemPaletteEntries Lib "gdi32" (ByVal hDC As Long, ByVal start As Long, ByVal entries As Long, ByVal ptrEntries As Long)
Public Declare Sub RealizePalette Lib "gdi32" (ByVal hPalette As Long)
Public Declare Sub SelectPalette Lib "gdi32" (ByVal hDC As Long, ByVal hPalette As Long, ByVal bln As Long)
Public Declare Function SetPixelFormat Lib "gdi32" (ByVal hDC As Long, ByVal i As Long, pfd As PIXELFORMATDESCRIPTOR) As Boolean
Public Declare Sub SwapBuffers Lib "gdi32" (ByVal hDC As Long)
Public Declare Function wglCreateContext Lib "OpenGL32" (ByVal hDC As Long) As Long
Public Declare Sub wglDeleteContext Lib "OpenGL32" (ByVal hContext As Long)
Public Declare Sub wglMakeCurrent Lib "OpenGL32" (ByVal l1 As Long, ByVal l2 As Long)

Public hPalette As Long
Public hGLRC As Long

Public spin As GLint
Public diffuseProperties(3) As GLfloat
Public lmodel_ambient(3) As GLfloat
Public xAngle As Integer
Public vThumbKeyFrame(3, 2) As GLfloat   'Three Key Frames
Public vFingerKeyFrame(3, 2) As GLfloat   'Three Key Frames
Public iKey As GLint

Public m_Palm As GLint
Public m_Digit As GLint

Public Const THUMB_TYPE = 0
Public Const FINGER_TYPE = 1

Public Const FIRST_FINGER = 0
Public Const SECOND_FINGER = 1
Public Const THIRD_FINGER = 2
Public Const FOURTH_FINGER = 3
Public Const THUMB_FINGER = 4

Public Const KEY_FRAME_COUNT = 4
Public Const KEY_INDEX_COUNT = 8
Public vIndex(KEY_INDEX_COUNT, 4) As GLint

Public Sub DefineKeyFrame()
    Dim i As Integer
    Dim j As Integer
    Dim k As Integer
    
    frmMain.sliderYaw.Value = 35
    
    iKey = 0
    
    'i is the key frame
    'j is the first
    'k is the digit
    'vKeyFrame(i,j,k)
    
    'Thumb
    'Digit 2
    vThumbKeyFrame(0, 1) = 10
    vThumbKeyFrame(1, 1) = 20
    vThumbKeyFrame(2, 1) = 40
    vThumbKeyFrame(3, 1) = 60
    'Digit 3
    vThumbKeyFrame(0, 2) = 10
    vThumbKeyFrame(1, 2) = 20
    vThumbKeyFrame(2, 2) = 60
    vThumbKeyFrame(3, 2) = 70
    
    '1-4 Finger Key Frame
    'Digit 1
    vFingerKeyFrame(0, 0) = 0
    vFingerKeyFrame(1, 0) = 20
    vFingerKeyFrame(2, 0) = 40
    vFingerKeyFrame(3, 0) = 65
    
    'Digit 2
    vFingerKeyFrame(0, 1) = 0
    vFingerKeyFrame(1, 1) = 20
    vFingerKeyFrame(2, 1) = 40
    vFingerKeyFrame(3, 1) = 65
    
    'Digit 3
    vFingerKeyFrame(0, 2) = 0
    vFingerKeyFrame(1, 2) = 20
    vFingerKeyFrame(2, 2) = 40
    vFingerKeyFrame(3, 2) = 65
    
    '----------------------Key Frame Index
    For i = 0 To KEY_INDEX_COUNT
        vIndex(i, FIRST_FINGER) = 0
        vIndex(i, SECOND_FINGER) = 0
        vIndex(i, THIRD_FINGER) = 0
        vIndex(i, FOURTH_FINGER) = 0
        vIndex(i, THUMB_FINGER) = 0
    Next
    
    'Animation Sequence
    'First Finger
    vIndex(0, FIRST_FINGER) = 0
    vIndex(1, FIRST_FINGER) = 1
    vIndex(2, FIRST_FINGER) = 2
    vIndex(3, FIRST_FINGER) = 3
    vIndex(4, FIRST_FINGER) = 3
    vIndex(5, FIRST_FINGER) = 3
    vIndex(6, FIRST_FINGER) = 3
    vIndex(7, FIRST_FINGER) = 3
    
    'Second Finger
    vIndex(1, SECOND_FINGER) = 0
    vIndex(2, SECOND_FINGER) = 1
    vIndex(3, SECOND_FINGER) = 2
    vIndex(4, SECOND_FINGER) = 3
    vIndex(5, SECOND_FINGER) = 3
    vIndex(6, SECOND_FINGER) = 3
    vIndex(7, SECOND_FINGER) = 3
    
    'Third Finger
    vIndex(2, THIRD_FINGER) = 0
    vIndex(3, THIRD_FINGER) = 1
    vIndex(4, THIRD_FINGER) = 2
    vIndex(5, THIRD_FINGER) = 3
    vIndex(6, THIRD_FINGER) = 3
    vIndex(7, THIRD_FINGER) = 3
    
    'Fourth Finger
    vIndex(3, FOURTH_FINGER) = 0
    vIndex(4, FOURTH_FINGER) = 1
    vIndex(5, FOURTH_FINGER) = 2
    vIndex(6, FOURTH_FINGER) = 3
    vIndex(7, FOURTH_FINGER) = 3
    
    'Thumb Finger
    vIndex(4, THUMB_FINGER) = 0
    vIndex(5, THUMB_FINGER) = 1
    vIndex(6, THUMB_FINGER) = 2
    vIndex(7, THUMB_FINGER) = 3

End Sub
Public Sub FatalError(ByVal strMessage As String)
    vIndex(5, THIRD_FINGER) = 3

    MsgBox "Fatal Error: " & strMessage, vbCritical + vbApplicationModal + vbOKOnly + vbDefaultButton1, "Fatal Error In " & App.Title
    Unload frmMain
    Set frmMain = Nothing
    End
End Sub
Public Sub SetupPixelFormat(ByVal hDC As Long)
    
    Dim pfd As PIXELFORMATDESCRIPTOR
    Dim PixelFormat As Integer
    pfd.nSize = Len(pfd)
    pfd.nVersion = 1
    pfd.dwFlags = PFD_SUPPORT_OPENGL Or PFD_DRAW_TO_WINDOW Or PFD_DOUBLEBUFFER Or PFD_TYPE_RGBA
    pfd.iPixelType = PFD_TYPE_RGBA
    pfd.cColorBits = 16
    pfd.cDepthBits = 16
    pfd.iLayerType = PFD_MAIN_PLANE
    PixelFormat = ChoosePixelFormat(hDC, pfd)
    If PixelFormat = 0 Then FatalError "Could not retrieve pixel format!"
    SetPixelFormat hDC, PixelFormat, pfd
End Sub
Public Sub SetupPalette(ByVal lhDC As Long)
    
    
    Dim PixelFormat As Long
    Dim pfd As PIXELFORMATDESCRIPTOR
    Dim pPal As LOGPALETTE
    Dim PaletteSize As Long
    PixelFormat = GetPixelFormat(lhDC)
    DescribePixelFormat lhDC, PixelFormat, Len(pfd), pfd
    If (pfd.dwFlags And PFD_NEED_PALETTE) <> 0 Then
        PaletteSize = 2 ^ pfd.cColorBits
    Else
        Exit Sub
    End If
    
    pPal.palVersion = &H300
    pPal.palNumEntries = PaletteSize
    Dim redMask As Long
    Dim GreenMask As Long
    Dim BlueMask As Long
    Dim i As Long
    redMask = 2 ^ pfd.cRedBits - 1
    GreenMask = 2 ^ pfd.cGreenBits - 1
    BlueMask = 2 ^ pfd.cBlueBits - 1
    For i = 0 To PaletteSize - 1
        With pPal.palPalEntry(i)
            .peRed = i
            .peGreen = i
            .peBlue = i
            .peFlags = 0
        End With
    Next
    GetSystemPaletteEntries frmMain.hDC, 0, 256, VarPtr(pPal.palPalEntry(0))
    hPalette = CreatePalette(pPal)
    If hPalette <> 0 Then
        SelectPalette lhDC, hPalette, False
        RealizePalette lhDC
    End If
End Sub

Public Sub auxSolidSphere(radius As GLdouble)
    On Error GoTo BadSphere
    Dim QuadOBJ As GLUquadric
    QuadOBJ = gluNewQuadric
    gluQuadricDrawStyle QuadOBJ, GLU_FILL
    gluQuadricNormals QuadOBJ, GLU_SMOOTH
    gluSphere QuadOBJ, radius, 16, 16
    Exit Sub
BadSphere:
    MsgBox "Error #" & CStr(Err.Number) & " has occured in " & CStr(Err.Source) & " during auxSolidSphere creation." & Chr$(13) & Chr$(10) & Chr$(13) & Chr$(10) & "Description: " & Err.Description
    Exit Sub
End Sub
